%Example signal noisy sine wave
t = -pi:0.01:pi;
x = linspace(-pi, pi, length(t));
noisySignal_1 = sin(x)+0.5*rand(1, length(x));
noisySignalLen = length(noisySignal_1);

%Declare oneEuro object
a = oneEuro;
%Alter filter parameters to tune
a.mincutoff = 1.0;
a.beta = 0.0;

%Rate parameter to use in filter (adjust to match your data)
f = 1/60; %ex 60 Hz

%Example using the filter on a single signal
filteredSignal = zeros(size(noisySignal_1));

for i = 1:noisySignalLen
    filteredSignal(i) = a.filter(noisySignal_1(i),f);
end

figure;
plot(t, noisySignal_1);
hold on;
plot(t, filteredSignal);

%Example using the filter on multiple signals

%Example signal noisy cosine wave
noisySignal_2 = cos(x)+0.5*rand(1, length(x));

%Array of signals (columnwise example)
noisySignalArr = [noisySignal_1' noisySignal_2'];

filteredSignalArr = zeros(size(noisySignalArr));

for i = 1:noisySignalLen
    filteredSignalArr(i,:) = a.filter(noisySignalArr(i,:),f);
end

figure;
subplot(1,2,1);
plot(t, noisySignal_1);
hold on;
plot(t, filteredSignalArr(:,1));
subplot(1,2,2);
plot(t, noisySignal_2);
hold on;
plot(t, filteredSignalArr(:,2));

